#include "gui.h"

// maksymalny czas oczekiwania na ulozenie
//#define MAX_TIME 10


std::string colorTab[] = {"red", "pink", "blue", "yellow", "brown", "green", "magenta", "silver", "lime", "grey", "orange", "violet", "indigo"};
float rozn_wys;
float rozn_szer;
unsigned int counter;
QListWidget *list;
QSlider *slider;
QGraphicsView *graph;


void ValetThread::run()
{
    QStringList formats;
    for (unsigned int i = 0; i < Mtemp.size(); i++)
        formats.push_back(Mtemp[i].c_str());
    list->addItems(formats);

    while (counter < Mtemp.size())
    {
        msleep(10*slider->value());
        list->setCurrentRow((int)counter);
        drawMovingCars();
    }
    exec();
}



void ValetThread::drawMovingCars()
{
    int i = counter++;
    int car_nr = whichCar(Mtemp[i][0]);
    int car_dir = Mtemp[i][1];

    if (cartemp[car_nr].kierunek == 'z')
    {
        if (car_dir == 'e')
        {
            gcartemp[car_nr]->moveBy(rozn_szer,0);
        }
        else if (car_dir == 'w')
        {
            gcartemp[car_nr]->moveBy(-rozn_szer,0);
        }
    }
    else if (cartemp[car_nr].kierunek == 'n')
    {
        if (car_dir == 'n')
        {
            gcartemp[car_nr]->moveBy(0,-rozn_wys);
        }
        else if (car_dir == 's')
        {
            gcartemp[car_nr]->moveBy(0,rozn_wys);
        }
    }
    //graph->show();
}


int ValetThread::whichCar(char car_name)
{
    for (unsigned int i = 0; i < cartemp.size(); i++)
        if (cartemp[i].name == car_name)
            return i;
    std::cout << "Nieznane " << car_name << "\n";
    return 9999;
}



void QtGui::startFun()
{

    thread = new ValetThread(this, gcar, car, MOVES);
    thread->start();
    if (thread->isFinished())
        std::cout << "FDOFIDF\n";
    //thread->wait();

}


QtGui::QtGui()
{
    SCENE_HEIGHT = 300;
    SCENE_WIDTH = 300;

    f_line = NULL;
    colorNum = 13;

    openFileButton = new QPushButton(QString::fromUtf8("Otwórz plik"), this);
    openFileButton->setGeometry(QRect(350, 20, 160, 30));
    openFileButton->setDisabled(false);

    startButton = new QPushButton(QString::fromUtf8("Rozpocznij poruszanie"), this);
    startButton->setGeometry(QRect(350, 60, 160, 30));
    startButton->setDisabled(true);

    exitButton = new QPushButton(QString::fromUtf8("Wyjście"), this);
    exitButton->setGeometry(QRect(350, 100, 160, 30));

    listLabel = new QLabel(QString::fromUtf8("Zbiór ruchów"), this);
    listLabel->setGeometry(QRect(385, 145, 100, 30));

    list = new QListWidget(this);
    list->setGeometry(QRect(360, 170, 130, 155));

    sliderLabel = new QLabel(QString::fromUtf8(" Prędkość\nporuszania"), this);
    sliderLabel->setGeometry(QRect(500, 140, 100, 30));
    sliderUpLabel = new QLabel(QString::fromUtf8("-"), this);
    sliderUpLabel->setGeometry(QRect(550, 175, 10, 40));
    sliderDownLabel = new QLabel(QString::fromUtf8("+"), this);
    sliderDownLabel->setGeometry(QRect(550, 280, 10, 40));

    slider = new QSlider(Qt::Vertical, this);
    slider->setGeometry(QRect(455, 180, 170, 130));
    slider->setMinimum(1);
    slider->setMaximum(100);
    slider->setSliderPosition(50);

    scene = new QGraphicsScene();

    graph = new QGraphicsView(scene, this);
    graph->setGeometry(QRect(10, 20, SCENE_HEIGHT+10, SCENE_WIDTH+10));
    graph->setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
    graph->setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
    graph->setAlignment(Qt::AlignLeft | Qt::AlignTop);

    graph->show();

    QObject::connect(openFileButton, SIGNAL(clicked()), this, SLOT(openFileFun()));
    QObject::connect(startButton, SIGNAL(clicked()), this, SLOT(startFun()));
    QObject::connect(exitButton, SIGNAL(clicked()), this, SLOT(finish()));

    setWindowTitle(tr("Valet Parking"));
    resize(600, 400);
}


void QtGui::finish()
{
    clear();
    close();
}



void QtGui::clear()
{
    //if (thread->isRunning())
    //    thread->exit();
    counter = 0;
    for (unsigned int i = 0; i < gcar.size(); i++)
    {
        scene->removeItem(gcar[i]);
        delete gcar[i];
    }
    gcar.clear();
    if (f_line != NULL)
    {
        scene->removeItem(f_line);
        f_line = NULL;
    }
    car.clear();
    t.clear();
    MOVES.clear();
    list->clear();
}

void QtGui::openFileFun()
{

    QString fileName = QFileDialog::getOpenFileName(this, QString::fromUtf8("Otwórz plik"));

    clear();

    prepare(fileName.toStdString());
    startButton->setEnabled(true);

    rozn_wys = SCENE_HEIGHT / (wysokosc);
    rozn_szer = SCENE_WIDTH / (szerokosc);

    drawFinishLine();
    drawCars();

    start_fun();

}


void QtGui::drawCars()
{
    QPen pen;
    QBrush brush(Qt::SolidPattern);

    for (unsigned int i = 0; i < car.size(); i++)
    {
        if (i != car_A)
        {
            pen.setColor(QColor(colorTab[i%colorNum].c_str()));
            brush.setColor(QColor(colorTab[i%colorNum].c_str()));
        }
        else
        {
            pen.setColor(QColor("black"));
            brush.setColor(QColor("black"));
        }

        if (car[i].kierunek == 'z')
        {
            gcar.push_back(scene->addRect((car[i].ay-1)*rozn_szer+5,
                                          (car[i].ax-1)*rozn_wys+5,
                                          (car[i].wektor+1)*rozn_szer-5,
                                          (rozn_wys-5),
                                          pen, brush));
        }

        else if (car[i].kierunek == 'n')
        {
            gcar.push_back(scene->addRect((car[i].ay-1)*rozn_szer+5,
                                          (car[i].ax-1)*rozn_wys+5,
                                          rozn_szer-5,
                                          (car[i].wektor+1)*rozn_wys-5,
                                          pen, brush));
        }

    }

}

void QtGui::drawFinishLine()
{

    QPen pen(Qt::black, 3, Qt::SolidLine, Qt::RoundCap, Qt::RoundJoin);

    switch (finish_line)
    {
    case LEFT:
    {
        f_line = scene->addLine(0, (exit_x-1)*rozn_wys, 0, exit_x*rozn_wys, pen);
        break;
    }

    case RIGHT:
    {
        f_line = scene->addLine(SCENE_WIDTH, (exit_x-1)*rozn_wys, SCENE_WIDTH, exit_x*rozn_wys, pen);
        break;
    }

    case UP:
    {
        f_line = scene->addLine((exit_y-1)*rozn_szer, 0, (exit_y)*rozn_szer, 0, pen);
        break;
    }

    case DOWN:
    {
        f_line = scene->addLine((exit_y-1)*rozn_szer, SCENE_HEIGHT+4, (exit_y)*rozn_szer, SCENE_HEIGHT+4, pen);
        break;
    }
    }

}
