#ifndef QTGUI_H
#define QTGUI_H

#include <QMainWindow>
#include <QPushButton>
#include <QGraphicsScene>
#include <QGraphicsView>
#include <QGraphicsItem>
#include <QFileDialog>
#include <QColor>
#include <QThread>
#include <QListWidget>
#include <QSlider>
#include <QLabel>

#include <iostream>
#include <string>

#include "valet.h"


class ValetThread : public QThread
{
    Q_OBJECT

public:
    //ValetThread(QObject* parent = 0) {};
    ValetThread(QObject* parent, std::vector<QGraphicsRectItem *> &gc, std::vector<SCar> &c, std::vector<std::string> &m)
    {
        parent = 0;
        gcartemp = gc;
        cartemp = c;
        Mtemp = m;
    }
    virtual ~ValetThread() {};


    std::vector<QGraphicsRectItem *> gcartemp;
    std::vector<SCar> cartemp;
    std::vector<std::string> Mtemp;

    void run();
    void drawMovingCars();
    int whichCar(char car_name);
};


class QtGui : public QMainWindow, public QtValet
{
    Q_OBJECT

public:
    QtGui();
    //~QtGui();

    std::vector<QGraphicsRectItem *> gcar;


private:
    enum DIR
    {
        UP, DOWN, LEFT, RIGHT
    };
    QGraphicsLineItem *f_line;

    int colorNum;

    void drawCars();
    void drawFinishLine();
    void clear();

    ValetThread *thread;

    int SCENE_HEIGHT;
    int SCENE_WIDTH;

    QLabel *listLabel;
    QLabel *sliderLabel;
    QLabel *sliderUpLabel;
    QLabel *sliderDownLabel;
    QPushButton *openFileButton;
    QPushButton *newMapButton;
    QPushButton *backButton;
    QPushButton *startButton;
    QPushButton *exitButton;
    QGraphicsScene *scene;
   // QGraphicsView *graph;

private slots:
    void openFileFun();
    void startFun();
    void finish();

};



#endif
